package com.rootsoft.oslibrary;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import android.os.PowerManager;
import android.os.Environment;
import android.os.StatFs;
import android.os.Process;
import android.app.ActivityManager.MemoryInfo;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.app.ActivityManager.RunningTaskInfo;
import android.content.BroadcastReceiver;
import android.os.RecoverySystem;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.CountDownTimer;
import android.os.Build;
import android.util.Log;
import android.app.ActivityManager;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("OperatingSystem")
@Permissions(values={"android.permission.INTERNET", "android.permission.REBOOT", "android.permission.DUMP", "android.permission.ACCESS_NETWORK_STATE","android.permission.BATTERY_STATS", "android.permission.KILL_BACKGROUND_PROCESSES", "android.permission.WRITE_SETTINGS", "android.permission.GET_TASKS"})
@Author("XverhelstX")
@Version(1.3f)

public class OSLibrary{
	
	
	private BA ba; 
	private String BatteryInfo;
	private String eventName;
	private List<ApplicationInfo> appList;
	//private String ACTIVITY_SERVICE;
	public String OS;
	
	
    /**
     * Initializes the Operating System Library.
     *
     */
	
	public void Initialize(BA ba, String EventName)
	{
	  this.ba = ba;
	  this.eventName = EventName.toLowerCase(BA.cul);
	  
	}
	
	 /**
     * Registers the battery receiver. Call this before getBatteryLevel.
     *
     */
	public void BatteryReceiver() {
		
		ba.activity.registerReceiver(this.mBatInfoReceiver, 

	    	    new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
		
	}
	
	private BroadcastReceiver mBatInfoReceiver = new BroadcastReceiver(){

	    @Override

	    public void onReceive(Context arg0, Intent intent) {

	      // TODO Auto-generated method stub

	      int level = intent.getIntExtra("level", 0);

	      BatteryInfo = String.valueOf(level) + "%";

	    }

	  };
	  
	  /**
	     * Returns the battery level.
	     *
	     */
	  public String getBatteryLevel() {
		  return BatteryInfo;
	  }
	  
	  /**
	     * Returns the name of the underlying board, like "goldfish".
	     *
	     */
	  public String getBoard() {
		  String Board = Build.BOARD;
		return Board;
		  
	  }
	  
	  /**
	     * Returns the system bootloader version number.
	     * Since api level 8.
	     *
	     */
	  public String getBootloader() {
		  String Bootloader = Build.BOOTLOADER;
		return Bootloader;
		  
	  }
	  
	  /**
	     * Returns the brand (e.g., carrier) the software is customized for, if any.
	     * 
	     *
	     */
	  public String getBrand() {
		  String Brand = Build.BRAND;
		return Brand;
		  
	  }
	  
	  /**
	     * Returns the name of the instruction set (CPU type + ABI convention) of native code.
	     * Since api level 4.
	     *
	     */
	  public String getCPUABI() {
		  String CPU = Build.CPU_ABI;
		return CPU;
		  
	  }
	  
	  /**
	     * Returns the name of the second instruction set (CPU type + ABI convention) of native code.
	     * Since api level 8.
	     *
	     */
	  public String getCPUABI2() {
		  String CPU2 = Build.CPU_ABI2;
		return CPU2;
		  
	  }
	  
	  /**
	     * Returns the name of the industrial design.
	     * 
	     *
	     */
	  public String getDevice() {
		  String Device = Build.DEVICE;
		return Device;
		  
	  }
	  
	  /**
	     * Returns a build ID string meant for displaying to the user
	     * API level 3
	     *
	     */
	  public String getDisplay() {
		  String Display = Build.DISPLAY;
		return Display;
		  
	  }

	  /**
	     * Returns a string that uniquely identifies this build. Do not attempt to parse this value.
	     * 
	     *
	     */
	  public String getFingerprint() {
		  String Finger = Build.FINGERPRINT;
		return Finger;
		  
	  }
	  
	  /**
	     * Returns the name of the hardware (from the kernel command line or /proc).
	     * API level 8.
	     *
	     */
	  public String getHardware() {
		  String Hardware = Build.HARDWARE;
		return Hardware;
		  
	  }
	  
	  /**
	     * Returns the host.
	     * 
	     *
	     */
	  public String getHost() {
		  String Host = Build.HOST;
		return Host;
		  
	  }
	  
	  /**
	     * Returns either a changelist number, or a label like "M4-rc20".
	     * 
	     *
	     */
	  public String getID() {
		  String ID = Build.ID;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the manufacturer of the product/hardware.
	     * 
	     *
	     */
	  public String getManufacturer() {
		  String ID = Build.MANUFACTURER;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the end-user-visible name for the end product.
	     * 
	     *
	     */
	  public String getModel() {
		  String ID = Build.MODEL;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the name of the overall product.
	     * 
	     *
	     */
	  public String getProduct() {
		  String ID = Build.PRODUCT;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the name of the overall product.
	     * Api Level 8
	     *
	     */
	  public String getRadio() {
		  String ID = Build.RADIO;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the name of the overall product.
	     * Api Level 9
	     *
	     */
	  public String getSerial() {
		  String ID = Build.SERIAL;
		return ID;
		  
	  }
	  
	  /**
	     * Returns Comma-separated tags describing the build, like "unsigned,debug".
	     * 
	     *
	     */
	  public String getTags() {
		  String ID = Build.TAGS;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the time.
	     * 
	     *
	     */
	  public long getTime() {
		  long ID = Build.TIME;
		return ID;
		  
	  }
	  
	  /**
	     * Returns the type of build, like "user" or "eng".
	     * 
	     *
	     */
	  public String getType() {
		  String ID = Build.TYPE;
		return ID;
		  
	  }
	  
	  
	  public String getUser() {
		  String ID = Build.USER;
		return ID;
		  
	  }
	  
	  /**
	     * The current development codename, or the string "REL" if this is a release build.
	     * API level 4.
	     *
	     */
	  public String getCodename() {
		  String ID = Build.VERSION.CODENAME;
		return ID;
		  
	  }
	  
	  /**
	     * The internal value used by the underlying source control to represent this build. E.g., a perforce changelist number or a git hash.
	     * 
	     *
	     */
	  public String getIncremental() {
		  String ID = Build.VERSION.INCREMENTAL;
		return ID;
		  
	  }
	  
	  /**
	     * The user-visible version string. E.g., "1.0" or "3.4b5".
	     * 
	     *
	     */
	  public String getRelease() {
		  String ID = Build.VERSION.RELEASE;
		return ID;
		  
	  }
	  
	  /**
	     * The user-visible SDK version of the framework
	     * 
	     *
	     */
	  public int getSDK() {
		  int ID = Build.VERSION.SDK_INT;
		return ID;
		  
	  }
	  
	  /**
	     * Makes a countdown timer from duration (in ms).
	     * 2 events are raised:
	     * eventname_ontick
	     * eventname_onfinish (OS as String)
	     * 
	     *
	     */
	  public void CountDownTimer(long duration) {
		  
		  new CountDownTimer(duration, 1000) {

			     public void onTick(long millisUntilFinished) {
			    	 ba.raiseEvent(this, eventName + "_ontick", new Object[] { millisUntilFinished } );
			     }

			     public void onFinish() {
			    	 OS = "Operating System Library Rocks! :)";
			    	 ba.raiseEvent(this, eventName + "_onfinish", new Object[] { OS });
			    	
			     }
			  }.start();
		  
	  }
	  
	  /**
	   * This calculates the CPU usage.
	   * 
	   * @return
	   */
	  public float calculateCPUusage() {
		    try {
		        RandomAccessFile reader = new RandomAccessFile("/proc/stat", "r");
		        String load = reader.readLine();

		        String[] toks = load.split(" ");

		        long idle1 = Long.parseLong(toks[5]);
		        long cpu1 = Long.parseLong(toks[2]) + Long.parseLong(toks[3]) + Long.parseLong(toks[4])
		              + Long.parseLong(toks[6]) + Long.parseLong(toks[7]) + Long.parseLong(toks[8]);

		        try {
		            Thread.sleep(360);
		        } catch (Exception e) {}

		        reader.seek(0);
		        load = reader.readLine();
		        reader.close();

		        toks = load.split(" ");

		        long idle2 = Long.parseLong(toks[5]);
		        long cpu2 = Long.parseLong(toks[2]) + Long.parseLong(toks[3]) + Long.parseLong(toks[4])
		            + Long.parseLong(toks[6]) + Long.parseLong(toks[7]) + Long.parseLong(toks[8]);

		        return (float)(cpu2 - cpu1) / ((cpu2 + idle2) - (cpu1 + idle1));

		    } catch (IOException ex) {
		        ex.printStackTrace();
		    }

		    return 0;
		} 
	  /**
	   * Reads all info about the CPU.
	   * @return
	   */
	  public String ReadCPUinfo()
	  {
	   ProcessBuilder cmd;
	   String result="";
	   
	   try{
	    String[] args = {"/system/bin/cat", "/proc/cpuinfo"};
	    cmd = new ProcessBuilder(args);
	    
	    java.lang.Process process = cmd.start();
	    InputStream in = process.getInputStream();
	    byte[] re = new byte[1024];
	    while(in.read(re) != -1){
	     System.out.println(new String(re));
	     result = result + new String(re);
	    }
	    in.close();
	   } catch(IOException ex){
	    ex.printStackTrace();
	   }
	   return result;
	  }
	 
	  
	  /**
	     * The total available memory on the system. This number should not be considered absolute: due to the nature of the kernel, 
	     * a significant portion of this memory is actually in use and needed for the overall system to run well.
	     * 
	     *
	     */
	  public long getAvailableMemory() {
		  MemoryInfo memoryInfo = new ActivityManager.MemoryInfo();
		  long ID = memoryInfo.availMem;
		return ID;
		  
	  }
	  
	  /**
	     * Set to true if the system considers itself to currently be in a low memory situation.
	     * 
	     *
	     */
	  public boolean setLowMemory() {
		  MemoryInfo memoryInfo = new ActivityManager.MemoryInfo();
		  boolean ID = memoryInfo.lowMemory;
		return ID;
	  }
	  
	  /**
	     * The threshold of availMem at which we consider memory to be low and start 
	     * killing background services and other non-extraneous processes.
	     * 
	     *
	     */
	  public long getThreshold() {
		  MemoryInfo memoryInfo = new ActivityManager.MemoryInfo();
		  long ID = memoryInfo.threshold;
		return ID;
		  
	  }
	  
	  /**
	     * Gets a list of all running application processess.
	     * 
	     *
	     */
	  @SuppressWarnings("static-access")
	public List<RunningAppProcessInfo> getRunningAppProcess() {
		  ActivityManager activityManager = (ActivityManager) BA.applicationContext.getSystemService(BA.applicationContext.ACTIVITY_SERVICE);
		  List<RunningAppProcessInfo> runningAppProcesses = activityManager.getRunningAppProcesses();
		return runningAppProcesses;
	  }
	  
	  /**
	     * Returns elapsed milliseconds of the time this process has run.
	     * 
	     *
	     */
	  public long getElaspedCPUTime() {
		  long ID = Process.getElapsedCpuTime();
		return ID;
		  
	  }
	  
	  /**
	     * Returns the GID assigned to a particular user name, or -1 if there is none.
	     * 
	     *
	     */
	  public int getGidForName(String name) {
		  int ID = Process.getGidForName(name);
		return ID;
		  
	  }
	  
	  /**
	     * Return the current priority of a thread, based on Linux priorities.
	     * 
	     *
	     */
	  public int getGidForName(int tid) {
		  int ID = Process.getThreadPriority(tid);
		return ID;
		  
	  }
	  
	  /**
	     * Returns the UID assigned to a particular user name, or -1 if there is none.
	     * 
	     *
	     */
	  public int getUidForName(String name) {
		  int ID = Process.getUidForName(name);
		return ID;
		  
	  }
	  
	  /**
	     * Kill the process with the given PID.
	     * 
	     *
	     */
	  public void killProcess(int pid) {
		  Process.killProcess(pid);
		
	  }
	  
	  /**
	     * Returns the identifier of this process, which can be used with killProcess(int) and sendSignal(int, int).
	     * 
	     *
	     */
	  public int myPid() {
		  int ID = Process.myPid();
		return ID;
		  
	  }
	  
	  /**
	     * Returns the identifier of this process's user.
	     *
	     */
	  public int myTid() {
		  int ID = Process.myTid();
		return ID;
		  
	  }
	  
	  /**
	     * Returns the identifier of the calling thread, which be used with setThreadPriority(int, int).
	     *
	     */
	  public int myUid() {
		  int ID = Process.myUid();
		return ID;
		  
	  }
	  
	  /**
	     * Send a signal to the given process.
	     * 
	     *
	     */
	  public void sendSignal(int pid, int signal) {
		  Process.sendSignal(pid, signal);
		
	  }
	  
	  /**
	     * Set the priority of a thread, based on Linux priorities.
	     * 
	     *
	     */
	  public void setThreadPriority(int tid, int priority) {
		  Process.setThreadPriority(tid, priority);
		
	  }
	  
	  /**
	     * Determine whether the current environment supports multiple processes.
	     *
	     */
	  public boolean supportsProcesses() {
		  boolean ID = Process.supportsProcesses();
		return ID;
		  
	  }
	  
	  /**
	     * Reboots the device in order to install the given update package.
	     * @throws IOException 
	     * 
	     *
	     */
	  public void installPackage(File packageFile) throws IOException {
		  RecoverySystem.installPackage(ba.context, packageFile);
		
	  }
	  
	  /**
	     * Reboots the device and wipes the user data partition.
	     * @throws IOException 
	     * 
	     *
	     */
	  public void rebootWipeUserData() throws IOException {
		  RecoverySystem.rebootWipeUserData(ba.context);
		
	  }
	  
	  /**
	     * Returns the available internal memory size.
	     *
	     */
	  public long getAvailableInternalMemorySize() {
          File path = Environment.getDataDirectory();
          StatFs stat = new StatFs(path.getPath());
          long blockSize = stat.getBlockSize();
          long availableBlocks = stat.getAvailableBlocks();
          return availableBlocks * blockSize;
		  
	  }
	  
	  /**
	     * Returns the total internal memory size.
	     *
	     */
	  public long getTotalInternalMemorySize() {
          File path = Environment.getDataDirectory();
          StatFs stat = new StatFs(path.getPath());
          long blockSize = stat.getBlockSize();
          long totalBlocks = stat.getBlockCount();
          return totalBlocks * blockSize;
	  }
	  
	  /**
	     * Returns if the external memory is available.
	     *
	     */
	  public boolean externalMemoryAvailable() {
          return android.os.Environment.getExternalStorageState().equals(android.os.Environment.MEDIA_MOUNTED);
      }
	  
	  	/**
	     * Returns the available external memory size.
	     * Returns -1 if the external memory is unavailable.
	     */
	  public long getAvailableExternalMemorySize() {
          if(externalMemoryAvailable()) {
              File path = Environment.getExternalStorageDirectory();
              StatFs stat = new StatFs(path.getPath());
              long blockSize = stat.getBlockSize();
              long availableBlocks = stat.getAvailableBlocks();
              return availableBlocks * blockSize;
      } else {
              return -1;
      }
	  }
	  
	  
	  	/**
	     * Returns the available internal memory size.
	     * Returns -1 if the internal memory is unavailable.
	     */
	  public long getTotalExternalMemorySize() {
          if(externalMemoryAvailable()) {
              File path = Environment.getExternalStorageDirectory();
              StatFs stat = new StatFs(path.getPath());
              long blockSize = stat.getBlockSize();
              long totalBlocks = stat.getBlockCount();
              return totalBlocks * blockSize;
      } else {
              return -1;
      	}
	  }
	  
	  
	  	/**
	     * The number of blocks that are free on the file system and available to applications.
	     * 
	     */
	  public int getAvailableBlocks(String Path) {
		  StatFs stat = new StatFs(Path);
		  int blocks = stat.getAvailableBlocks();
		  return blocks;
	  }
	  
	  	/**
	     * The total number of blocks on the file system.
	     * 
	     */
	  public int getBlockCount(String Path) {
		  StatFs stat = new StatFs(Path);
		  int blocks = stat.getBlockCount();
		  return blocks;
	  }
	  
	  	/**
	     * The size, in bytes, of a block on the file system.
	     * 
	     */
	  public int getBlockSize(String Path) {
		  StatFs stat = new StatFs(Path);
		  int blocks = stat.getBlockSize();
		  return blocks;
	  }
	  
	  	/**
	     * The total number of blocks that are free on the file system, including reserved blocks (that are not available to normal applications).
	     * 
	     */
	  public int getFreeBlocks(String Path) {
		  StatFs stat = new StatFs(Path);
		  int blocks = stat.getFreeBlocks();
		  return blocks;
	  }
	  
	  /**
	     * Perform a restat of the file system referenced by this object.
	     * 
	     */
	  public void restat(String Path) {
		  StatFs stat = new StatFs(Path);
		  stat.restat(Path);		  
	  }
	  
	  /**
	     * Reboot the device. Will not return if the reboot is successful. 
	     * reason	code to pass to the kernel (e.g., "recovery") to request special boot modes, or null.
	     * Api level 8
	     */
	  public void reboot(String Reason) {
		  PowerManager pm = (PowerManager)BA.applicationContext.getSystemService(Context.POWER_SERVICE);	
		  pm.reboot(Reason);
	  }
	  
	  /**
	     * Force the device to go to sleep. Overrides all the wake locks that are held
	     * 
	     * time	is used to order this correctly with the wake lock calls. The time should be in the SystemClock.uptimeMillis() time base.
	     */
	  public void goToSleep(long time) {
		  PowerManager pm = (PowerManager)BA.applicationContext.getSystemService(Context.POWER_SERVICE);		
		  pm.goToSleep(time);
	  }
	  
	  /**
	     * User activity happened.
	     * Turns the device from whatever state it's in to full on, and resets the auto-off timer.
	     * 
	     * when	is used to order this correctly with the wake lock calls. This time should be in the SystemClock.uptimeMillis() time base.
	     * 
	     * noChangeLights	should be true if you don't want the lights to turn on because of this event. This is set when the power key goes down. 
	     * We want the device to stay on while the button is down, but we're about to turn off. Otherwise the lights flash on and then off and it looks weird.
	     */
	  public void userActivity(long when, boolean noChangeLights) {
		  PowerManager pm = (PowerManager)BA.applicationContext.getSystemService(Context.POWER_SERVICE);	
		  pm.userActivity(when, noChangeLights);
	  }
	  
	  /**
	   * Have the system immediately kill all background processes associated with the given package.
	   * @param packageName
	   */
	  public void killBackgroundProcesses (String packageName) {
		  
		  ActivityManager activityManager = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
		  activityManager.killBackgroundProcesses(packageName);
		  
	  }
	  
	  /**
	   * Return a list of the tasks that the user has recently launched, with the most recent being first and older ones after in order.
	   * @param maxNum
	   * @param flags
	   * @return
	   */
	  public List<ActivityManager.RecentTaskInfo> getRecentTasks (int maxNum, int flags) {
		  
		  ActivityManager activityManager = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
		  List<ActivityManager.RecentTaskInfo> list = activityManager.getRecentTasks(maxNum, flags);
		  return list;
		  
	  }
	  
	  /**
	   * Returns a list of application processes that are running on the device.
	   * 
	   * @return
	   */
	  public List<ActivityManager.RunningAppProcessInfo> getRunningAppProcesses () {
		  ActivityManager am = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
		  List<ActivityManager.RunningAppProcessInfo> l = am.getRunningAppProcesses();
		  return l; 
	  }
	  
	  /**
	   * Return a list of the services that are currently running.
	   * maxNum	The maximum number of entries to return in the list. The actual number returned may be smaller, depending on how many services are running.

	   * @return
	   */
	  public List<ActivityManager.RunningServiceInfo> getRunningServices (int maxNum) {
		  
		  ActivityManager activityManager = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
		  List<ActivityManager.RunningServiceInfo> list = activityManager.getRunningServices(maxNum);
		  return list; 
	  }
	  
	  /**
	   * RReturn a list of the tasks that are currently running, with the most recent being first and older ones after in order. Note that "running" does not mean any of the task's code is currently loaded or activity -- 
	   * the task may have been frozen by the system, so that it can be restarted in its previous state when next brought to the foreground.
	   * @return
	   */
	  public List<ActivityManager.RunningTaskInfo> getRunningTasks (int maxNum) {
		  
		  ActivityManager activityManager = (ActivityManager)BA.applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
		  List<ActivityManager.RunningTaskInfo> list = activityManager.getRunningTasks(maxNum);
		  return list; 
	  }
	  
	  /**
	   * Gives information about the running app processes.
	   * Declare and Initialize 3 lists
	   * 
	   * @param list1 returns the process names.
	   * @param list2 returns the pid.
	   * @param list3 returns the process name and pid.
	   * @return
	   */
	public List<RunningAppProcessInfo> RunningAppProcessInfo(List<String> list1, List<Integer> list2, List<String> list3) {
		  
		  ActivityManager am = (ActivityManager) BA.applicationContext.getSystemService(BA.applicationContext.ACTIVITY_SERVICE);
		    List<RunningAppProcessInfo> list = am.getRunningAppProcesses();
		    for (RunningAppProcessInfo proc : list) {
		    	list1.add(proc.processName);
		    	list2.add(proc.pid);
		    	list3.add(proc.processName + ": "  + proc.pid);
		        Log.v("B4A", proc.processName + " : " + proc.pid);
		    }
			return list;
	  }
	  
	  /**
	   * Gives information about the running services.
	   * Declare and Initialize 3 lists
	   * 
	   * @param list1 returns the service name.
	   * @param list2 returns the pid.
	   * @param list3 returns the service name and pid.
	   * @return
	   */
	public List<ActivityManager.RunningServiceInfo> RunningServiceInfo(int maxNum, List<String> list1, List<Integer> list2, List<String> list3) {
		  
		  ActivityManager am = (ActivityManager) BA.applicationContext.getSystemService(BA.applicationContext.ACTIVITY_SERVICE);
		    List<ActivityManager.RunningServiceInfo> list = am.getRunningServices(maxNum);
		    for (ActivityManager.RunningServiceInfo proc : list) {
		    	list1.add(proc.process);
		    	list2.add(proc.pid);
		    	list3.add(proc.process + ": "  + proc.pid);
		        Log.v("B4A", proc.process + " : " + proc.pid);
		    }
			return list;
	  }
	  
	  /**
	   * Gives information about the running tasks.
	   * Declare and Initialize 3 lists
	   * 
	   * @param list1 returns a unique id.
	   * @param list2 returns number of activities in this task.
	   * @param list3 returns number of activities that are currently running (not stopped and persisted) in this task.
	   * @return
	   */
	  
	  public List<RunningTaskInfo> RunningTaskInfo(int maxNum, List<Integer> list1, List<Integer> list2, List<Integer> list3) {
		  
		  ActivityManager am = (ActivityManager) BA.applicationContext.getSystemService(BA.applicationContext.ACTIVITY_SERVICE);
		    List<ActivityManager.RunningTaskInfo> list = am.getRunningTasks(maxNum);
		    for (ActivityManager.RunningTaskInfo proc : list) {
		    	list1.add(proc.id);
		    	list2.add(proc.numActivities);
		    	list3.add(proc.numRunning);
		        Log.v("B4A", proc.numActivities + " : " + proc.id);
		    }
			return list;
	  }
	  
	  
	  public void PackagesInfo() {
	        PackageManager pm = BA.applicationContext.getPackageManager();
	        appList = pm.getInstalledApplications(PackageManager.GET_UNINSTALLED_PACKAGES);
	    }

	    public String getInfo(String name) {
	        if (name == null) {
	            return null;
	        }
	        for (ApplicationInfo appinfo : appList) {
	            if (name.equals(appinfo.processName)) {
	                // System.out.println(name + "===" + appinfo.className);
	                return appinfo.toString();
	            }
	        }
	        return null;
	    }

	  
	  
	  
	  
	  	/**
	     * 
	     * 
	     */
	  public String formatSize(long size) {
          String suffix = null;
  
          if (size >= 1024) {
                  suffix = "KiB";
                  size /= 1024;
                  if (size >= 1024) {
                          suffix = "MiB";
                          size /= 1024;
                  }
          }
  
          StringBuilder resultBuffer = new StringBuilder(Long.toString(size));
  
          int commaOffset = resultBuffer.length() - 3;
          while (commaOffset > 0) {
                  resultBuffer.insert(commaOffset, ',');
                  commaOffset -= 3;
          }
  
          if (suffix != null)
                  resultBuffer.append(suffix);
          return resultBuffer.toString();
	  		}
		}


	




	  
